
% Exemplos de resposta em frequencia

R1 = 6.8e3 ; 
C1 = 22e-9 ; 

R2 = 4e3 ; 
C2 = 22e-9 ; 
L2 = 640e-3 ; 

% 1a. ordem 

tau = R1*C1 ;

num1 = 1 ; 
den1 = [ tau 1 ] ; 

ord1 = tf(num1,den1) ; 

% 2a. ordem 

wn = sqrt(inv(L2*C2)) ;
zeta = R2/(2*L2*wn) ; 

num2 = wn^2 ; 
den2 = [ 1 2*zeta*wn wn^2 ] ; 

ord2 = tf(num2,den2) ; 

% 3a. ordem 

ord3 = series(ord1,ord2) ; 

% Anlise da estabilidade relativa

figure(1) 
margin(ord3) 

% Anlise do erro de regime

ord3mf = feedback(ord3,1)

figure(2) 
step(ord3mf) 

pause

% Busca do ganho crtico atravs do lugar de razes - na prtica seria por
% ensaio de variao do ganho da planta

figure(3) 
rlocus(ord3) 

% Ensaio de resposta ao degrau para determinar os parmetros do
% Ziegler-Nichols

Kcr = 2.07 ; 

ord3kcr = series(Kcr,ord3)

ord3kcrmf = feedback(ord3kcr,1)

figure(5) 
step(ord3kcrmf,0.0025) 

pause

% Projeto do controlador PI 

Kp = 0.45*Kcr ; 

Pcr = inv(1.06e4/(2*pi)) ;

Ti = Pcr/1.2 ; 

numPI = [ Kp Kp/Ti ] ; 
denPI = [ 1 0 ] ; 

Gc = tf(numPI,denPI) ; 

figure(6)
bode(Gc)

pause

ord3PI = series(Gc,ord3) ; 

figure(7)
margin(ord3PI) 

pause

% Anlise do erro de regime

ord3PIgmf = feedback(ord3PI,1) ; 

figure(8) 
step(ord3PIgmf) 

